const int buttonPin = 4;   
const int ledPin = 3;      


int ledState = LOW;         
int buttonState;            
int lastButtonState = LOW;  

unsigned long lastDebounceTime = 0;  // the last time the output pin was toggled
unsigned long debounceDelay = 50;    // the debounce time; increase if the output flickers





void setup() {
  pinMode(buttonPin, INPUT);
  pinMode(ledPin, OUTPUT);

  digitalWrite(ledPin, ledState);
}

void loop() {
  
  int reading = digitalRead(buttonPin);

  if (reading != lastButtonState) {
    lastDebounceTime = millis();
  }

  if ((millis() - lastDebounceTime) > debounceDelay) {
    if (reading != buttonState) {
      buttonState = reading;
      if (buttonState == HIGH) 
        ledState = HIGH;
      else
        ledState = LOW;
      }
    }
  

  digitalWrite(ledPin, ledState);

  lastButtonState = reading;
}
